package sde.to.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import org.apache.log4j.Logger;

/**
 * バイナリ・テキストファイルの入出力関数
 * 
 * 2014.03.20
 * @author ohno
 *
 */

public class CFileIO {
	
	// log4jの設定
		final Logger logger = Logger.getLogger(CFileIO.class);
		
	/**
	 * テキストファイル入力
	 * 
	 * 2014.03.20
	 * 
	 * @param fpath ファイルパス
	 * 
	 * 
	 * @throws IOException 
	 * 
	 */
void textFileInput(String fpath) throws IOException{
	// ...ファイルを表すFileクラスを生成。
				File file = new File(fpath);

	try{
		//ファイル入力
			FileReader reader = new FileReader(file);
		// ファイルリーダ
			BufferedReader buff = new BufferedReader(reader);
		//一行バッファ
			String oneline = null;
			
			double total = 0.;
			
		//一行とりだし
			while( (oneline = buff.readLine()) != null){
				
				logger.trace(oneline);	
			}

		} catch (FileNotFoundException e) {
			// ...事前にチェック済み
			logger.error(e.getMessage());
			//
			assert(false);
		} 
	}
	


/**
 * バイナリファイル入力
 * 
 * 2014.03.20
 * 
 * @param fpath ファイルパス
 * 
 * 
 * @throws IOException 
 * 
 */
void binFileInput(String fpath) throws IOException{
// ...ファイルを表すFileクラスを生成。
			File file = new File(fpath);

try{
	//ファイル入力
		FileInputStream in = new FileInputStream(file);
	
	byte ch;
	
	//一行とりだし
		while( (ch = (byte)in.read()) != -1){
			
			System.out.print(Integer.toString(ch)+" ");	
			System.out.print(Integer.toBinaryString(ch)+" ");	
			System.out.print(Integer.toHexString(ch)+"\n");
			
		}

	} catch (FileNotFoundException e) {
		// ...事前にチェック済み
		logger.error(e.getMessage());
		//
		assert(false);
	} 
}


/**
 * 試験
 * */
public static void main(String arg[]){
	
	
	CFileIO one = new CFileIO();
	
	String fpath = "/home/ohno/public/fileIO/sources.list";
	
	try {
		one.binFileInput(fpath);
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
}

}



