package sde.to.util;


import org.apache.commons.math3.random.MersenneTwister;
import org.apache.log4j.Logger;

/**
 * メルセンヌ ツイスター乱数発生クラス(抽象クラス)
 * 
 * 2010.02.19
 * 
 * @author ohno
 *
 */
public abstract class CRandomGenerator {
	
	// log4jの設定
	final Logger logger = Logger.getLogger(CRandomGenerator.class);
	
	/**
	 * メルセンヌ ツイスター乱数器
	 */
	private static MersenneTwister mT = null;
	
	/**
	 * 一様乱数発生クラス
	 * ラッピング
	 * 
	 */
	protected CRandomGenerator(){
		
		// カレント時刻でシード発生
		if(mT == null)mT = new MersenneTwister(null);
		
	}
	
	/**
	 * シード設定
	 * @param seed
	 */
	protected void setSead(int seed){
		mT.setSeed(seed);
	}
	
	/**
	 * 一様乱数発生
	 */
	protected double nextDouble(){
		return this.mT.nextDouble();
	}
	
	/**
	 * 一様乱数発生（Boolean)
	 */
	protected boolean nextBoolean(){
		return this.mT.nextBoolean();
	}
	
	/**
	 * 正規乱数発生
	 */
	protected double nextGaussian(){
		return this.mT.nextGaussian();
	}

}
