package sde.to.util;

import java.util.Calendar;
import java.util.GregorianCalendar;

import org.apache.log4j.Logger;

/**
 * 
 * 経過時刻の計測
 * 
 * 
 * 使用方法
 * 
 * 次を繰り返す。
 * CTimmer.start();
 * CTimmer.stop();
 * 
 * 経過時間の印字
 * CTimmer.print(”メッセージ”);
 * 
 * 
 * @author ohno
 *
 */
public class CTimmer {
	// log4jの設定
	static final Logger logger = Logger.getLogger(CTimmer.class);
			
	/**
	 * 測定開始時刻の設定領域
	 */
	static long start = 0;
	
	/**
	 * 測定終了時刻の設定領域
	 */
	static long stop = 0;
	
	/**
	 * start - stop の時刻設定領域
	 */
	static long ctime = 0;
	
	/**
	 * 測定開始時刻の設定
	 */
	static public void start(){
		
		Calendar cal = new GregorianCalendar();
		
		// set now
		CTimmer.start = cal.getTimeInMillis();
	}
	
	/**
	 * 測定終了時刻の設定
	 * 常に　stop-start間を蓄積する。
	 */
	static public void stop(){
		Calendar cal = new GregorianCalendar();
		CTimmer.stop = cal.getTimeInMillis();
		CTimmer.ctime += CTimmer.stop - CTimmer.start;
		
	}
	
	/**
	 * 測定終了時刻の設定
	 */
	static public void stopstart(){
		stop();
		start();
		
	}
	
	/**
	 * 計測時間のリセット
	 */
	static public void reset(){
		CTimmer.ctime = 0;
	}
	
	/**
	 * いままでの計測時間の和の印字
	 * 
	 * @param msg
	 * @throws CAssertionException
	 */
	static public void print(String msg) throws CAssertion{
		
		//stopstart();
		
		double tim = CTimmer.ctime ;
		tim /= 1000;
		
		double min = tim/60;
		
		int  ihour =(int) min/60;
		
		int imin = (int) min%60;
		
		tim =  tim%60;
		
		double r = CUtility.cvDouble(tim, 1.0, 2);
		
		//min = CUtility.cvDouble(min, 1.0, 0);
		
		//hour =  CUtility.cvDouble(hour, 1.0, 0);
		
		// 経過秒
		logger.trace("<TIMER>"+"["+ihour+":"+imin+":"+r+"]"+msg);
		
	}
	
	/**
	 * 試験
	 */
static public void main(String arg[]){
	
	
	//double v = 1.23456;
	//double scale =1.;
	//int ika =2;
	
	//System.out.println(CUtility.cvDouble(v, scale, ika));
	
	long st = 1500;
	CTimmer.start();
	try {
		Thread.sleep(st);
	} catch (InterruptedException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	
	CTimmer.print(".."+st);
	
	try {
		Thread.sleep(st);
	} catch (InterruptedException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	
	CTimmer.print(".."+st);
	
	try {
		Thread.sleep(st);
	} catch (InterruptedException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	
	CTimmer.print(".."+st);
	
	
	
}

}


